


(************************************************************************)
(*                                                                      *)
(*                    Version 2.1a with error checks                    *)
(*                                                                      *)
(************************************************************************)

IMPLEMENTATION MODULE SETofINTEGER;

(************************************************************************)
(*                                                                      *)
(*           Version 2.1a for Sun/4, SunOS 4.1.1, m2c-Compiler          *)
(*     Version 2.1b for IBM-PC/AT, MSDOS 3.30, Taylor Modula-2 3.00     *)
(*     Version 2.1c for IBM-PC/AT, MSDOS 3.30, Fitted Modula-2 2.00     *)
(*                                                                      *)
(*                 (c) Richard Breuer [BR] 1990 - 1992                  *)
(*            e-mail: ricki@rwthi3.informatik.rwth-aachen.de            *)
(*              mail: Brunssumstr. 6, 5100 Aachen, Germany              *)
(*                                                                      *)
(************************************************************************)
(*                                                                      *)
(* Purpose:                                                         	*)
(*                                                                      *)
(*   This  IMPLEMENTATION MODULE  has just the purpose  to create a set	*)
(*   class in the module body.  Here stands the definition of the order	*)
(*   for the class.							*)
(*                                                                      *)
(************************************************************************)
(*                                                                      *)
(* Notes: ( * = IMPORTANT )						*)
(*                                                                      *)
(*  *(1) Do never remove the VAR in the declaration of Cmp_anyType if	*)
(*	 the results shall be ok.					*)
(*  *(2) Do never change the values of i or j in Cmp_anyType, even if	*)
(*	 they are passed as VAR parameters (this is just for technical	*)
(*       reasons)							*)
(*                                                                      *)
(************************************************************************)
(*                                                                      *)
(* Revisions:                                                         	*)
(*                                                                      *)
(*   01/09/92	Version 2.1						*)
(*   11/04/91	Version 2.0 						*)
(*   06/12/91	english comments [BR]					*)
(*   03/12/91	use _ instead of @ in order to allow usage of the m4 	*)
(*		macro processor. The following strings are to be	*)
(*		replaced (all in lower case letters!):			*)
(*			_anyType	name of the data type which	*)
(*					shall be used			*)
(*			_Import		here you must insert an IMPORT	*)
(*					statement for non standard data	*)
(*					types				*)
(*			_Reldef		definition of the relation that	*)
(*					defines an order for two values *)
(*					i and j.			*)
(*		Look into the m4 files that come with this package to	*)
(*		see how the standard set classes are created [BR]	*)
(*   03/12/91	Version 1.1c 						*)
(*   02/28/91	Versions 1.1a,1.1b 					*)
(*   02/21/91   Changes for updated module SETs. PC version via string	*)
(*		replacements [BR]					*)
(*   09/12/90   Changes for updated module SETs [BR]                    *)
(*   09/11/90   Versions 1.0a,1.0b 	                                *)
(*                                                                      *)
(************************************************************************)

  FROM SYSTEM IMPORT
    TSIZE;

  FROM SETs IMPORT
    SETCreateClass,
    SETCompareProcType,
    SETCompareResultType;




  PROCEDURE CmpINTEGER(VAR i,j: INTEGER): SETCompareResultType;
  (* Look at notes (1),(2) in the module header comments *)

  BEGIN
    (* this is the location for defining the ordering relation for the two
       variables i and j *)


	IF (i<j) THEN RETURN(SETLess) END;
	IF (i>j) THEN RETURN(SETGreater) END;
	RETURN(SETEqual);


  END CmpINTEGER;

BEGIN
  (* Creation of the set class for INTEGER data *)
  (* The m2c compiler allows type casts with procedure types. Therefore this
      version may use the above declaration of Cmp_anyType. But beware
     of using VAR when passing paramters in order to make Cmp_anyType
     compatible to SETCompareProcType, PROCEDURE(ADDRESS,ADDRESS). A generic
     procedure declaration with call by value parameters is not possible
     (you might work with ARRAY OF BYTE parameters but in this case there
     seems to be no working type cast) *)
  SETCreateClass(SETCompareProcType(CmpINTEGER),TSIZE(INTEGER),
		 SETofINTEGERclass)
END SETofINTEGER.
